﻿Imports System.IO
Imports Tea_Timer_Professional.DataSet1
Public Class fEinstellungen
    Private _DataFile As New FileInfo("Tee.Xml")
    'Form Close und Load Event
    Private Sub fEinstellungen_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        DataSet1.ReadXml(_DataFile.FullName)
    End Sub
    Private Sub fEinstellungen_FormClosed(sender As Object, e As FormClosedEventArgs) Handles MyBase.FormClosed
        DataSet1.WriteXml(_DataFile.FullName)
    End Sub
    'Klick Events - Buttons
    Private Sub btnTemperaturMinus_Click(sender As Object, e As EventArgs) Handles btnTemperaturMinus.Click
        'verringert Temperatur um 5°
        Temperaturaendern(-5)
    End Sub
    Private Sub btnTemperaturPlus_Click(sender As Object, e As EventArgs) Handles btnTemperaturPlus.Click
        'erhöht Temperatur um 5°
        Temperaturaendern(5)
    End Sub
    Private Sub btnZiehzeitPlus_Click(sender As Object, e As EventArgs) Handles btnZiehzeitPlus.Click
        'Ziehzeit erhöhen
        Ziehzeitaendern("+")
    End Sub
    Private Sub btnZiehzeitMinus_Click(sender As Object, e As EventArgs) Handles btnZiehzeitMinus.Click
        'Ziehzeit verkürzen
        Ziehzeitaendern("-")
    End Sub
    Private Sub btnstart_Click(sender As Object, e As EventArgs) Handles btnstart.Click
        'Sub zum starten des Timers
        'prüfen ob Ton agespielt werden soll
        Dim Sound As Boolean = My.Settings.Sound
        'Ziehzeit in Sekunden umrechnen
        Dim ZiehSekunden As Integer = Integer.Parse(lblZiehzeitSekunden.Text)
        Dim ZiehMinuten As Integer = Integer.Parse(lblZiehzeitMinuten.Text)
        Dim Ziehzeit As Integer = ZiehSekunden + ZiehMinuten * 60
        'wenn keine Zeit vergeben wurde, abbruch der Sub
        If Ziehzeit = 0 Then
            MessageBox.Show("Bitte Ziehzeit eingeben.")
            Exit Sub
        End If
        'Temperaturzeit in Sekunden umrechnen
        Dim AbkuehlSekunden As Integer = Integer.Parse(lblAbkuehlzeitSekunden.Text)
        Dim AbkuehlMinuten As Integer = Integer.Parse(lblAbkuehlzeitMinuten.Text)
        Dim Abkuehlzeit As Integer = AbkuehlSekunden + AbkuehlMinuten * 60
        'aktuelle Form ausblenden
        Me.Hide()
        'Wenn Abkühlzeit größer als 0, dann zeigen der Form fTimer Abkühlen
        If Abkuehlzeit > 0 Then
            Dim frmAbkuehlzeit As New fTimer
            With frmAbkuehlzeit
                .Sound = Sound
                .Zeit = Abkuehlzeit
                .Ziehen = False
                .ShowDialog(Me)
            End With
        End If
        'zeigen der Form fTimer für die Ziehzeit
        Dim frmZiehzeit As New fTimer
        With frmZiehzeit
            .Sound = Sound
            .Zeit = Ziehzeit
            .Ziehen = True
            .ShowDialog(Me)
        End With
        Me.Show()
    End Sub
    Private Sub btnbeenden_Click(sender As Object, e As EventArgs) Handles btnbeenden.Click
        'Sub zum beenden des Programms
        Me.Close()
    End Sub
    Private Sub btnloeschen_Click_1(sender As Object, e As EventArgs) Handles btnloeschen.Click
        'Sub zum löschen aus dem Dataset
        'prüfen ob eine Spalte über bleibt
        Dim i As Integer = 0
        For Each dtteesortenrow As DTTeesortenRow In DataSet1.DTTeesorten
            i = i + 1
        Next
        If i = 1 Then
            MessageBox.Show("der letzte Eintrag kann nicht gelöscht werden")
            Exit Sub
        End If
        Dim Spalte = DirectCast(DirectCast(DTTeesortenBindingSource.Current, DataRowView).Row, DTTeesortenRow)
        DataSet1.DTTeesorten.RemoveDTTeesortenRow(Spalte)
    End Sub
    Private Sub btnNeu_Click(sender As Object, e As EventArgs) Handles btnNeu.Click
        'Sub zum Eintragen eines neuen Tees
        DTTeesortenBindingSource.EditNew(Of frmNeu)
    End Sub
    Private Sub DTTeesortenDataGridView_CellContentDoubleClick(sender As Object, e As DataGridViewCellEventArgs) Handles DTTeesortenDataGridView.CellContentDoubleClick
        'Sub zum bearbeiten eines Tees
        DTTeesortenBindingSource.EditCurrent(Of frmNeu)
    End Sub
    'Klick Events - MenuStrip1
    Private Sub BeendenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles BeendenToolStripMenuItem.Click
        Me.Close()
    End Sub
    Private Sub EinstellungenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles EinstellungenToolStripMenuItem.Click
        Dim frmEinstellungen As New fProgrammeinstellungen
        frmEinstellungen.Show(Me)
    End Sub
    'Change Events
    Private Sub lblTemperatur_TextChanged(sender As Object, e As EventArgs) Handles lblTemperatur.TextChanged
        'Temperatur aus lblTemperatur auslesen und Abkuehlzeit entsprechend ändern
        Dim Temperatur As Integer = Integer.Parse(lblTemperatur.Text)
        Select Case Temperatur
            Case = 100 : TemperaturinZeit(0)
            Case = 95 : TemperaturinZeit(My.Settings.Temp95)
            Case 90 : TemperaturinZeit(My.Settings.Temp90)
            Case = 85 : TemperaturinZeit(My.Settings.Temp85)
            Case = 80 : TemperaturinZeit(My.Settings.Temp80)
            Case = 75 : TemperaturinZeit(My.Settings.Temp75)
            Case = 70 : TemperaturinZeit(My.Settings.Temp70)
            Case = 65 : TemperaturinZeit(My.Settings.Temp65)
            Case 60 : TemperaturinZeit(My.Settings.Temp60)
        End Select
    End Sub
    'Subs und Funktionen
    Private Sub Temperaturaendern(Faktor As Integer)
        'Sub zum ändern der Temperatur
        Dim Temperatur As Integer = Integer.Parse(lblTemperatur.Text)
        Temperatur = Temperatur + Faktor
        If Temperatur > 100 OrElse Temperatur < 60 Then Exit Sub
        lblTemperatur.Text = Temperatur.ToString
    End Sub
    Private Sub Ziehzeitaendern(op As String)
        'Intervall aus den Einstellungen lesen
        Dim Intervall As Decimal = My.Settings.Zeitintervall
        Dim Sekunden As Decimal = Integer.Parse(lblZiehzeitSekunden.Text)
        Dim Minuten As Integer = Integer.Parse(lblZiehzeitMinuten.Text)
        If op = "+" Then
            'Sekunden erhöhen
            Sekunden = Sekunden + Intervall
            'wenn Sekunden >= 60, dann Sekunden -60 und Minuten +1
            If Sekunden >= 60 Then
                Sekunden = Sekunden - 60
                Minuten = Minuten + 1
            End If
        Else
            'Sekunden verringern
            'Abbruch, wenn Minuten und Sekunden auf 0 stehen
            If Minuten = 0 AndAlso Sekunden = 0 Then Exit Sub
            Sekunden = Sekunden - Intervall
            'wenn Sekunden < 0, dann Sekunden +60 und Minuten -1
            If Sekunden < 0 Then
                Sekunden = Sekunden + 60
                Minuten = Minuten - 1
            End If
        End If
        'Minuten und Sekunden ggf mit voranstehender 0 in Labels schreiben
        If Minuten < 10 Then
            lblZiehzeitMinuten.Text = "0" & Minuten.ToString
        Else
            lblZiehzeitMinuten.Text = Minuten.ToString
        End If
        If Sekunden < 10 Then
            lblZiehzeitSekunden.Text = "0" & Sekunden.ToString
        Else
            lblZiehzeitSekunden.Text = Sekunden.ToString
        End If
    End Sub
    Private Sub TemperaturinZeit(Zeit As Integer)
        'Sub zum ändern der Abkühlzeit je nach Temperatur
        lblAbkuehlzeitMinuten.Text = (Zeit \ 60).ToString
        lblAbkuehlzeitSekunden.Text = (Zeit Mod 60).ToString
    End Sub
End Class
